# List resource metadata — API reference

> Returns keys and values for the requested resource, with pagination.

Source: https://upfour.io/docs/api/metadata/list-resource-metadata

[Developers](https://upfour.io/docs/api.md)/[Resource metadata](https://upfour.io/docs/api/metadata.md)

Returns keys and values for the requested resource, with pagination.

GET https://app.upfour.io/v1/metadata

scope metadata.read stable returns 200

## Parameters

| Field | Type | Description |
| --- | --- | --- |
| `resource_type` required | string one of`monitor` `heartbeat` `incident` `client` | query parameter |
| `resource_id` required | uuid | query parameter |

## Returns

A successful request returns `200` with application/json.

Response fields 2 top-level fields

| Field | Type | Description |
| --- | --- | --- |
| `data` | ResourceMetadata[]  · nullable | |
| Each item · 8 fields FieldTypeDescription `created_at` string (date-time) `id` uuid `key` string `organization_id` uuid `resource_id` uuid `resource_type` string one of`monitor` `heartbeat` `incident` `client` `updated_at` string (date-time) `value` string | | |
| `pagination` | Pagination | |
| Pagination · 5 fields FieldTypeDescription `cursor` string  · nullable `has_more` boolean `limit` integer 1–250 `next_cursor` string  · nullable `prev_cursor` string  · nullable | | |

## Errors

Only the errors this operation can return. Every error uses the [same envelope](https://upfour.io/docs/api/responses.md).

| Status | Code | Meaning |
| --- | --- | --- |
| 400 | [bad_request](https://upfour.io/docs/api/errors#code-bad_request) | The request is malformed or fails validation. |
| 404 | [not_found](https://upfour.io/docs/api/errors#code-not_found) | The requested resource does not exist or is outside the caller's scope. |

Every call can also return `unauthorized` (401), `rate_limit_exceeded` (429) or `internal_error` (500 / 502). See [Responses and errors](https://upfour.io/docs/api/responses.md).

[NextReplace resource metadata](https://upfour.io/docs/api/metadata/replace-resource-metadata.md)

## Request

### cURL

```bash
curl -s "https://app.upfour.io/v1/metadata?resource_type=monitor&resource_id=00000000-0000-4000-8000-000000000001" \
  -H "Authorization: Bearer $UP4_API_KEY"
```

### JavaScript

```javascript
const res = await fetch("https://app.upfour.io/v1/metadata?resource_type=monitor&resource_id=00000000-0000-4000-8000-000000000001", {
  headers: {
    Authorization: `Bearer ${process.env.UP4_API_KEY}`,
  },
});
console.log(res.status, await res.json());
```

### Python

```python
import os
import requests

res = requests.get(
    "https://app.upfour.io/v1/metadata?resource_type=monitor&resource_id=00000000-0000-4000-8000-000000000001",
    headers={"Authorization": f"Bearer {os.environ['UP4_API_KEY']}"},
)
print(res.status_code, res.json())
```

### Go

```go
package main

import (
	"fmt"
	"io"
	"net/http"
	"os"
)

func main() {
	req, _ := http.NewRequest("GET", "https://app.upfour.io/v1/metadata?resource_type=monitor&resource_id=00000000-0000-4000-8000-000000000001", nil)
	req.Header.Set("Authorization", "Bearer "+os.Getenv("UP4_API_KEY"))
	res, err := http.DefaultClient.Do(req)
	if err != nil {
		panic(err)
	}
	defer res.Body.Close()
	out, _ := io.ReadAll(res.Body)
	fmt.Println(res.StatusCode, string(out))
}
```

### PHP

```php
<?php
$ch = curl_init("https://app.upfour.io/v1/metadata?resource_type=monitor&resource_id=00000000-0000-4000-8000-000000000001");
curl_setopt_array($ch, [
    CURLOPT_RETURNTRANSFER => true,
    CURLOPT_HTTPHEADER => [
        "Authorization: Bearer " . getenv("UP4_API_KEY"),
    ],
]);
$response = curl_exec($ch);
echo curl_getinfo($ch, CURLINFO_RESPONSE_CODE), " ", $response, "\n";
curl_close($ch);
```

## Response

### 200

```json
{
  "data": [
    {
      "created_at": "2026-10-27T09:00:00Z",
      "id": "00000000-0000-4000-8000-000000000002",
      "key": "team",
      "organization_id": "00000000-0000-4000-8000-000000000003",
      "resource_id": "00000000-0000-4000-8000-000000000001",
      "resource_type": "monitor",
      "updated_at": "2026-10-27T09:00:00Z",
      "value": "platform"
    },
    {
      "created_at": "2026-10-27T09:00:00Z",
      "id": "00000000-0000-4000-8000-000000000004",
      "key": "tier",
      "organization_id": "00000000-0000-4000-8000-000000000003",
      "resource_id": "00000000-0000-4000-8000-000000000001",
      "resource_type": "monitor",
      "updated_at": "2026-10-27T09:00:00Z",
      "value": "1"
    }
  ],
  "pagination": {
    "cursor": null,
    "has_more": false,
    "limit": 50,
    "next_cursor": null,
    "prev_cursor": null
  }
}
```

### 400

```json
{
  "error": {
    "code": "bad_request",
    "message": "The request is malformed or fails validation.",
    "request_id": "req_…"
  }
}
```

### 404

```json
{
  "error": {
    "code": "not_found",
    "message": "The requested resource does not exist or is outside the caller's scope.",
    "request_id": "req_…"
  }
}
```
